---
title: 'get TypedArray[@@species]'
slug: Web/JavaScript/Reference/Global_Objects/TypedArray/@@species
tags:
  - JavaScript
  - Property
  - Prototype
  - TypedArray
  - TypedArrays
---
<div>{{JSRef}}</div>

<p>The <code><strong>TypedArray[@@species]</strong></code> accessor property returns the constructor of a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array</a>.</p>

<h2 id="Description">Description</h2>

<p>The <code>species</code> accessor property returns the default constructor for <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array</a> objects. Subclass constructors may over-ride it to change the constructor assignment.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Species_in_ordinary_objects">Species in ordinary objects</h3>

<p>The <code>species</code> property returns the default constructor function, which is one of the typed array constructors for a given <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array</a> object:</p>

<pre class="brush: js">Int8Array[Symbol.species];    // function Int8Array()
Uint8Array[Symbol.species];   // function Uint8Array()
Float32Array[Symbol.species]; // function Float32Array()
</pre>

<h3 id="Species_in_derived_objects">Species in derived objects</h3>

<p>In a derived collection object (e.g. your custom typed array <code>MyTypedArray</code>), the <code>MyTypedArray</code> species is the <code>MyTypedArray</code> constructor. However, you might want to overwrite this, in order to return a parent <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/TypedArray#TypedArray_objects">typed array</a> object in your derived class methods:</p>

<pre class="brush: js">class MyTypedArray extends Uint8Array {
  // Overwrite MyTypedArray species to the parent Uint8Array constructor
  static get [Symbol.species]() { return Uint8Array; }
}</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-get-%typedarray%-@@species', 'get %TypedArray% [ @@species ]')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.builtins.TypedArray.@@species")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("TypedArray")}}</li>
 <li>{{jsxref("Symbol.species")}}</li>
</ul>
